; Acorn Keywrite. 
; The keywrite program is entered at MAIN (0280).
; When this program is first used after switching on 
; a form feed can be sent to the screen to program the 6845 by pressing the 'r' key. 
;
; The program then accepts pairs of Hex characters before sending them to the screen,
; by-passing the control interpreter to allow any code to be sent.
; The control keys provide the following functions
;
; l Line feed		g space 
; ^ delete		p space
; V carriage return	s space 
; r form feed		m return to monitor 
;
; KEYWRT ACORN 6502 Assembler 

KEYWRT	= $0280 
TEMP	= $0026 
RESTRT	= $FF04 
DISPLA	= $FE0C 
VDU	= $0300 

	.org	$280

MAIN:
	JSR DISPLA
	BCC SEND	; hex key ?
CONTRL:
	AND #$07
	BEQ RETURN
	TAY		; look up control keys in table
	LDA TABLE-01,Y
SENDER:
	JSR VDU
	JMP MAIN
SEND:
	ASL A
	ASL A
	ASL A
	ASL A
	STA TEMP
	JSR DISPLA
	BCS CONTRL
	ORA TEMP ; mix in low digit
	ORA #$80 ; fool control character check
	BMI SENDER ; forced branch to sender
RETURN:
	JMP RESTRT ; M key returns to monitor

TABLE:
	.byte $20 ; G key gives space bar
	.byte $20 ; P key gives space bar
	.byte $20 ; S key gives space bar
	.byte $0A ; L key gives line-feed
	.byte $0C ; R key gives form-feed
	.byte $7F ; ^ key gives delete
	.byte $0D ; ^ I key gives carriage return 
